<template>
  <AppAbstractSearch
    :results-loader="resultsLoader"
    :value="value.name"
    @input="select({ id: value && value.id, name: $event })"
    @search="search">
    <template
      v-if="$slots['additional-slot']"
      #additional-slot>
      <slot name="additional-slot"/>
    </template>
    <template #suggestion-item="{ suggestion }">
      <div
        @click="select(suggestion)"
        class="suggestion">
        <div class="suggestion-wrapper">
          <div class="suggestion-unit">
            {{ suggestion.name }}
          </div>
        </div>
      </div>
    </template>
    <template #button-item>
      Оформить запрос
    </template>
  </AppAbstractSearch>
</template>

<script>
import mapFilters from '~/assets/js/helpers/map-filters';

import AppAbstractSearch from '~/components/redesign/app-search/app-abstract-search';

export default {
  name: 'AppSearchVin',
  components: {
    AppAbstractSearch,
  },
  props: {
    value: {
      type: Object,
      default() {
        return {
          id: null,
          name: null,
        };
      },
    },
  },
  methods: {
    ...mapFilters(['brandSlug', 'vendorCodeSlug']),
    resultsLoader(query) {
      return new Promise((resolve) => {
        this.$axios.$get('/_main/partItemName/get', { params: { searchString: query } })
          .then(({ data }) => {
            if (data) {
              resolve(data);
            }
            resolve([]);
          });
      });
    },
    select(value) {
      this.$emit('input', value);
    },
    search() {
      this.$emit('search');
    },
  },
};
</script>

<style lang="postcss">
</style>
